#include <windows.h>
#include "ezjig.h"
#include "ini.h"
#include "view.h"
#include "game.h"
#include "desk.h"
#include "koukaon.h"

HWND		main_hWnd;
HMENU		main_menu;
GAME		GM;
KOUKAON		koukaon;
DESK		DK;
VIEW		View[5];

void nop() {};//gpȂ̃[jO߂̖ʂȃR[fBO

LRESULT	CALLBACK WndProc			(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL	check_menu					(HWND hwnd, WPARAM wParam);					//̃\[X̍Ōɂ
HWND	guide_init					(HINSTANCE hInst, HWND owner, MYBIT *img);	//GUIDE.CPP
void	guide_term					();											//GUIDE.CPP
HWND	basicline_create_window		(HINSTANCE hInstance, HWND owner_hwnd);		//BASICLINE.CPP
HWND	PatternLine_create_window	(HINSTANCE hInstance, HWND owner_hwnd);		//PATTERNLINE.CPP

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPreInst, LPSTR lpszCmdLine, int nCmdShow)
{
	if (lpszCmdLine==NULL) nop();//gpȂ̃[jO߂̖ʂȃR[fBO

	HWND		hWnd;
	MSG			msg;
	WNDCLASS	myProg;
	char		szInstance[]	= "ezjig_Instance";		//  ̃AvP[VŗL̕
	char		szClassName[]	= "ezjig_Class";
	int			i;
	RECT		desktop_rcRect;
	HWND		desktop_hWnd;

	//  OpenMutex ł́AdN邱Ƃ̂ŁAȂNGCg
	HANDLE hMutex = CreateMutex( NULL/*MUTEX_ALL_ACCESS*/, FALSE, szInstance );
	if( ::GetLastError() == ERROR_ALREADY_EXISTS ) {
		// ɋNĂ
		CloseHandle(hMutex);
		return FALSE;
	}

	read_ini(ini);
	koukaon.init(ini.sound_dir);

	if (!hPreInst) {
		myProg.style            =CS_HREDRAW | CS_VREDRAW;
		myProg.lpfnWndProc      =WndProc;
		myProg.cbClsExtra       =0;
		myProg.cbWndExtra       =0;
		myProg.hInstance        =hInstance;
		myProg.hIcon            =LoadIcon(hInstance, "EZJIG_ICON");//NULL;
		myProg.hCursor			=LoadCursor(NULL, IDC_ARROW);
		myProg.hbrBackground    =NULL;//(HBRUSH)GetStockObject(WHITE_BRUSH);
		myProg.lpszMenuName		=NULL;
		myProg.lpszClassName    =szClassName;
		if (!RegisterClass(&myProg))
			return FALSE;
	}
	main_menu	= (HMENU)LoadMenu(hInstance, "IDM_MAIN_MENU");
	hWnd = CreateWindow(szClassName,
						"ezjig",
						WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						NULL,
						main_menu,
						hInstance,
						NULL);

	main_hWnd	= hWnd;

//	ShowWindow(hWnd, nCmdShow);
	ShowWindow(hWnd, SW_MAXIMIZE);
	UpdateWindow(hWnd);

	ZeroMemory( &msg, sizeof(msg) );
    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    write_ini(ini);
	return (msg.wParam);
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{

//	TRACE((s,"%d",msg))


	HINSTANCE hInstance = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);

	switch (msg) {
	case WM_CREATE:				/* ʍ쐬 */
		GM.Init(hWnd);
		DragAcceptFiles(hWnd, TRUE);/*hbOhbv\ɂ*/
		check_menu(hWnd, 0);
		if (ini.seiretu==TRUE)
			SetWindowText(hWnd, "exjig <񃂁[h>");
		GM.FileOpen();
		break;
	case WM_COMMAND:
		switch(LOWORD(wParam)) {
		case IDM_FOPEN://J
			GM.FileOpen();
			break;
		case IDM_SAVE://ԕۑ
			GM.Save();
			break;
		case IDM_RESTART://ׂɂ
			GM.ReStart();
			break;
		case IDM_EXIT://I
			SendMessage(hWnd, WM_CLOSE, 0, 0);
			break;
		case IDM_BACK_RGB:
			if (DK.ChangeRGB()==TRUE) {
				GM.DisplayAll();
			}
			break;
		case IDM_BACK_TILE:
			View[2].Init(hWnd, ini.back_dir, 0, 0, 1);
			break;
		case IDM_GUIDE:
			check_menu(hWnd, wParam);
			if (GM.Playing()) {
				guide_init(hInstance, hWnd, GM.GetImgPtr());
			}
			break;
		case IDM_GUIDE_NASI:
			check_menu(hWnd, wParam);
			if (GM.Playing()) {
				guide_term();
			}
			break;
		case IDM_GUIDE_BACK:
			check_menu(hWnd, wParam);
			if (GM.Playing()) {
				DK.SetBackImg(GM.GetImgPtr());
				GM.DisplayAll();
			}
			break;
		case IDM_PIECE_KATACHI:
			basicline_create_window(hInstance, hWnd);
			break;
		case IDM_PIECE_PATTERN:
			{
				int rc = MessageBox(hWnd,"܍HBCĂʂ肭B", "exjig", MB_OKCANCEL);
				if (rc==IDOK) {
					PatternLine_create_window(hInstance, hWnd);
				}
			}
			break;
		case IDM_HELP:
			{
				char	fname[MAX_PATH];
				wsprintf(fname, "%s%s", ini.exe_dir, "\\program\\@.html");
				if(ShellExecute(hWnd, NULL, fname, NULL, NULL, SW_SHOWNORMAL) <= (HINSTANCE)32)
					MessageBox(hWnd, "u@vt@CJ܂łB", "ezjig", MB_OK);
			}
			break;
		default:
			check_menu(hWnd, wParam);
		}
		break;
	case VIEW_SELMSG://ViewʑI
		GM.FileSelect(wParam, lParam);
		break;
	case WM_DROPFILES:
		GM.FileDrop(wParam);
		break;
	case MSG_MASK2:
		GM.Mask2();
		break;
	case MSG_MASK3:
		GM.Mask3();
		break;
	case MSG_CREATE1:
		GM.Create1();
		break;
	case MSG_CREATE2:
		GM.Create2();
		break;
	case MSG_CREATE3:
		GM.Create3();
		break;
	case MSG_CREATE_END:
		GM.CreateEnd();
		break;
	case WM_LBUTTONDOWN:
	case WM_RBUTTONDOWN:
	case WM_MBUTTONDOWN:
		GM.ButtonDown(msg, wParam, lParam);
		break;
	case WM_LBUTTONUP:
	case WM_RBUTTONUP:
	case WM_MBUTTONUP:
		GM.ButtonUp(msg, wParam, lParam);
		break;
	case WM_MOUSEMOVE:
		GM.MouseMove(msg, wParam, lParam);
		break;
	case WM_MOUSEWHEEL:
		RECT			r;
		POINT			p;
		GetCursorPos(&p);
		for (int i=0; i<5; i++) {
			GetWindowRect(View[i].GethWnd(), &r);
			if (p.x>r.left && p.x<r.right && p.y>r.top && p.y<r.bottom) {
				SendMessage(View[i].GethWnd(), WM_MOUSEWHEEL, wParam, lParam);
				break;
			}
		}
		break;
	case WM_KEYDOWN:
		switch (wParam) {
		case VK_SPACE:
			if (ini.seiretu==TRUE) {
				GM.seiretu_modify(0.0, 0.0, 0.0, TRUE);
			}
			else {
				if (!GM.IsBusy()) {
					GetCursorPos(&p);
					ScreenToClient(hWnd, &p);
					GM.Space(p);
				}
			}
			break;
		case VK_F5:
			{
				char	fname[MAX_PATH];
				wsprintf(fname, "%s%s", ini.exe_dir, "\\piece.bmp");
				GM.SaveTopPiece(fname);
				MessageBox(NULL,"piece.bmpo͂܂B","ezjig",MB_OK);
			}
			break;
		case VK_F6:
			{
				char	fname[MAX_PATH];
				wsprintf(fname, "%s%s", ini.exe_dir, "\\ezjig_ini.txt");
				write_ini_txt(ini, fname);
				MessageBox(NULL,"ezjig_ini.txto͂܂B","ezjig",MB_OK);
			}
			break;
		case VK_F7:
			if (ini.seiretu==FALSE) {
				ini.seiretu		= TRUE;
				SetWindowText(hWnd, "exjig <񃂁[h>");
			}
			else {
				ini.seiretu		= FALSE;
				SetWindowText(hWnd, "exjig");
			}
			break;
		case VK_F8:
			if (ini.seiretu==TRUE) {
				GM.seiretu_write();
			}
			break;
		case VK_F9:
			if (trace_flg==FALSE) {
				trace_flg	= TRUE;
				MessageBox(NULL,"trace on","ezjig",MB_OK);
			}
			else {
				trace_flg	= FALSE;
				MessageBox(NULL,"trace off","ezjig",MB_OK);
			}
			break;
		case VK_UP:
			if (GM.Ended()) {
				if (GetAsyncKeyState(VK_CONTROL)&0x80000)
					GM.ending_3(0.0, 0.0, 0.0, 0.0, +1);
				else
				if (GetAsyncKeyState(VK_SHIFT)&0x80000)
					GM.ending_3(+10.0, +10.0, 0.0, 0.0, 0.0);
				else
					GM.ending_3(0.0, 0.0, 0.0, +1.0, 0);
			}
			if (ini.seiretu==TRUE) {
				if (GetAsyncKeyState(VK_SHIFT)&0x80000)
					GM.seiretu_modify(+1.0, 0.0, 0.0, FALSE);
				else
					GM.seiretu_modify(0.0, 0.0, +1.0, FALSE);
			}
			break;
		case VK_DOWN:
			if (GM.Ended()) {
				if (GetAsyncKeyState(VK_CONTROL)&0x80000)
					GM.ending_3(0.0, 0.0, 0.0, 0.0, -1);
				else
				if (GetAsyncKeyState(VK_SHIFT)&0x80000)
					GM.ending_3(-10.0, -10.0, 0.0, 0.0, 0.0);
				else
					GM.ending_3(0.0, 0.0, 0.0, -1.0, 0);
			}
			if (ini.seiretu==TRUE) {
				if (GetAsyncKeyState(VK_SHIFT)&0x80000)
					GM.seiretu_modify(-1.0, 0.0, 0.0, FALSE);
				else
					GM.seiretu_modify(0.0, 0.0, -1.0, FALSE);
			}
			break;
		case VK_RIGHT:
			if (GM.Ended()) {
				if (GetAsyncKeyState(VK_CONTROL)&0x80000)
					GM.ending_3(0.0, 0.0, 0.0, 0.0, +1);
				else
					GM.ending_3(0.0, 0.0, +1.0, 0.0, 0);
			}
			break;
		case VK_LEFT:
			if (GM.Ended()) {
				if (GetAsyncKeyState(VK_CONTROL)&0x80000)
					GM.ending_3(0.0, 0.0, 0.0, 0.0, -1);
				else
					GM.ending_3(0.0, 0.0, -1.0, 0.0, 0);
			}
			break;
		}
		break;
	case WM_TIMER:
		GM.TimeOut(msg, wParam, lParam);
		break;
	case WM_PAINT:
		GM.Paint(msg, wParam, lParam);
		break;
	case WM_CLOSE:
		koukaon.close();
		if (ini.end_save==TRUE) {
			if (GM.Playing()) {	//ĂȂƂ͌_Z[u
				GM.Save(FALSE);
			}
		}
		DestroyWindow(hWnd);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return(DefWindowProc(hWnd, msg, wParam, lParam));
	}
	return (0L);
}


BOOL check_menu(HWND hwnd, WPARAM wParam)
{
	HMENU		hmenu, hsubmenu1, hsubmenu2;
	BOOL		rc=FALSE;
	WORD		menu_id;
	char		str[100];

	menu_id		= LOWORD(wParam);
	//Iԕۑ
	if (menu_id==IDM_END_SAVE) {
		rc				= TRUE;
		ini.end_save	= TRUE;
	}
	//IԕۑȂ
	if (menu_id==IDM_END_SAVE_NASI) {
		rc				= TRUE;
		ini.end_save	= FALSE;
	}
	//߰
	if ((menu_id & 0xf000)==IDM_0_PIECE) {
		rc				= TRUE;
		ini.pi_num		= menu_id - IDM_0_PIECE;
	}
	//傫
	if ((menu_id & 0xf000)==IDM_0_STRETCH) {
		rc				= TRUE;
		ini.pi_size		= menu_id - IDM_0_STRETCH;
	}
	//]
	if (menu_id==IDM_KAITEN) {
		rc				= TRUE;
		ini.pi_kaiten	= TRUE;
	}
	//]Ȃ
	if (menu_id==IDM_KAITEN_NASI) {
		rc				= TRUE;
		ini.pi_kaiten	= FALSE;
	}
	//]
	if (menu_id==IDM_HANTEN) {
		rc				= TRUE;
		ini.pi_hanten	= TRUE;
	}
	//]Ȃ
	if (menu_id==IDM_HANTEN_NASI) {
		rc				= TRUE;
		ini.pi_hanten	= FALSE;
	}
	//KCh
	if (menu_id==IDM_GUIDE) {
		rc				= TRUE;
		ini.guide		= TRUE;
	}
	//KChȂ
	if (menu_id==IDM_GUIDE_NASI) {
		rc				= TRUE;
		ini.guide		= FALSE;
	}
	//KChwiɕ\
	if (menu_id==IDM_GUIDE_BACK) {
		rc				= TRUE;
		if (ini.guide_back==FALSE)
			ini.guide_back	= TRUE;
		else
			ini.guide_back	= FALSE;
	}
	//TEh
	if (menu_id==IDM_SOUND_ON) {
		rc				= TRUE;
		ini.sound		= TRUE;
	}
	//TEhȂ
	if (menu_id==IDM_SOUND_OFF) {
		rc				= TRUE;
		ini.sound		= FALSE;
	}

	hmenu			= main_menu;

	if (ini.pi_num==0)
		wsprintf(str, "ݎgp");
	else
		wsprintf(str, "%d߰", ini.pi_num);
	ModifyMenu(hmenu, 1, MF_BYPOSITION, MF_STRING, str);

	if (ini.pi_size==0)
		wsprintf(str, "LkȂ");
	else
		wsprintf(str, "%d߸", ini.pi_size);
	ModifyMenu(hmenu, 2, MF_BYPOSITION, MF_STRING, str);

	hsubmenu1		= GetSubMenu(hmenu, 0); 
	hsubmenu2 		= GetSubMenu(hsubmenu1, 2); 
	CheckMenuRadioItem(hsubmenu2, IDM_END_SAVE_NASI, IDM_END_SAVE, IDM_END_SAVE_NASI+ini.end_save, MF_BYCOMMAND);

	hsubmenu1		= GetSubMenu(hmenu, 1); 
	CheckMenuRadioItem(hsubmenu1, IDM_0_PIECE, IDM_0_PIECE+1000, IDM_0_PIECE+ini.pi_num, MF_BYCOMMAND);

	hsubmenu1		= GetSubMenu(hmenu, 2); 
	CheckMenuRadioItem(hsubmenu1, IDM_0_STRETCH, IDM_0_STRETCH+1000, IDM_0_STRETCH+ini.pi_size, MF_BYCOMMAND);

	hsubmenu1		= GetSubMenu(hmenu, 3); 
	hsubmenu2 		= GetSubMenu(hsubmenu1, 0); 
	CheckMenuRadioItem(hsubmenu2, IDM_KAITEN_NASI, IDM_KAITEN, IDM_KAITEN_NASI+ini.pi_kaiten, MF_BYCOMMAND);
	hsubmenu2		= GetSubMenu(hsubmenu1, 1); 
	CheckMenuRadioItem(hsubmenu2, IDM_HANTEN_NASI, IDM_HANTEN, IDM_HANTEN_NASI+ini.pi_hanten, MF_BYCOMMAND);
	hsubmenu2		= GetSubMenu(hsubmenu1, 2); 
	CheckMenuRadioItem(hsubmenu2, IDM_GUIDE_NASI, IDM_GUIDE, IDM_GUIDE_NASI+ini.guide, MF_BYCOMMAND);
	if (ini.guide_back==TRUE)
		CheckMenuRadioItem(hsubmenu2, IDM_GUIDE_BACK, IDM_GUIDE_BACK, IDM_GUIDE_BACK, MF_BYCOMMAND);
	else
		CheckMenuItem(hsubmenu2, IDM_GUIDE_BACK, MF_UNCHECKED | MF_BYCOMMAND);
	hsubmenu2		= GetSubMenu(hsubmenu1, 4); 
	CheckMenuRadioItem(hsubmenu2, IDM_SOUND_OFF, IDM_SOUND_ON, IDM_SOUND_OFF+ini.sound, MF_BYCOMMAND);

	DrawMenuBar(hwnd);
	return(rc);
}

