// game.cpp


#define _TRACE_OFF_


#include <windows.h>
#include <windowsx.h>
#include "ezjig.h"
#include "ini.h"
#include "game.h"
#include "desk.h"
#include "view.h"
#include "koukaon.h"

BZ*		bzline_init		(int &pi_num, int &img_w, int &img_h, BOOL seiretu, RECT &setretu_rect0, RECT &seiretu_rect1);
HWND	guide_init		(HINSTANCE hInst, HWND owner, MYBIT *img);
HWND	guide_term		();

extern	DESK		DK;
extern	VIEW		View[5];
extern	void		nop();//gpȂ̃[jO߂̖ʂȃR[fBO
extern	KOUKAON		koukaon;

GAME::GAME()
{
	view_sel_no_image	= -1;
	view_sel_no_mask	= -1;
}

GAME::~GAME()
{
}

void GAME::Init(HWND hwnd)
{
	hWnd				= hwnd;
	mouse_button		= 0;
	sel					= -1;
	yukou_num			= 0;
	elap_time			= 0;
	timer_on			= FALSE;
	DK.Init(hwnd);
	desk				= DK.GetDeskPtr();
	joint				= FALSE;
}

void GAME::FileOpen()
{
	Reset();
	view_sel_no_image	= -1;
	view_sel_no_mask	= -1;

	if (View[0].GetStatus()==0 || View[0].GetStatus()==3) {
		View[0].Init(hWnd, ini.img_dir, 0, 0, 1);
	}
	else {
		View[0].Show();
	}

	if (ini.pi_num==0) {//ݎgp
		RECT	r;
		POINT	p;
		if (View[1].GetStatus()==0 || View[1].GetStatus()==3) {
			GetWindowRect(View[0].GethWnd(), &r);
			p.x		= r.left;
			p.y		= r.bottom;
			ScreenToClient(hWnd, &p);
			View[1].Init(hWnd, ini.mask_dir, p.x, p.y, 1);
		}
		else {
			View[1].Show();
		}
	}
}

void GAME::FileSelect(WPARAM wParam, LPARAM lParam)
{
	if (IsBusy()) {
		MessageBox(hWnd, "܍쐬","ezjig",MB_OK);
		return;
	}
	if (lParam==99999) {	//IĂȂ
		if (wParam==0)
			view_sel_no_image	= -1;
		if (wParam==1)
			view_sel_no_mask	= -1;
		return;
	}
	if (wParam==2) {		//wi^CI
		DK.ChangeTile(View[2].GetFname(lParam));
		DisplayAll();
		return;
	}
	if (wParam==0) {		//摜̑I
		view_sel_no_image	= lParam;
	}
	if (wParam==1) {		//p^[̑I
		view_sel_no_mask	= lParam;
	}

	//Q[̊Jn
	if (ini.pi_num==0) {
		if (view_sel_no_image>=0 && view_sel_no_mask>=0) {
			Start(View[0].GetFname(view_sel_no_image), View[1].GetFname(view_sel_no_mask));//}XNJn
		}
	}
	else {
		Start(View[0].GetFname(view_sel_no_image), NULL);//}XNȂJn
	}
}

void GAME::FileDrop(WPARAM wParam)
{
	if (IsBusy()) {
		MessageBox(hWnd, "܍쐬","ezjig",MB_OK);
		return;
	}
	if (ini.pi_num==0) {
		MessageBox(hWnd, "s[XIĂ","ezjig",MB_OK);
		return;
	}

	//Q[̊Jn
	if (DragQueryFile((HDROP)wParam, 0xFFFFFFFF, NULL, 0)>0) {
		char	wfname1[MAX_PATH];
		char	wfname2[MAX_PATH];
		wfname1[0]	= '\0';
		wfname2[0]	= '\0';
		DragQueryFile((HDROP)wParam, 0, wfname1, sizeof(wfname1));
		DragFinish((HDROP)wParam);
		if (wfname1[0]=='"') {
			lstrcpy(wfname2, wfname1+1);
			wfname2[lstrlen(wfname2)-1]	= '\0';
		}
		else
			lstrcpy(wfname2, wfname1);
		Start(wfname2, NULL);
	}
}

void GAME::Reset()
{
//	hWnd					= 0;
	view_sel_no_image		= 0;
	view_sel_no_mask		= 0;
	img_fname[0]			= '\0';
	CP.Reset();
	P.Reset();
	image.Reset();
	mask.Reset();
	disp_piece_no			= 0;
	mouse_button			= 0;
	mouse.x					= 0;
	mouse.y					= 0;
	mouse_old.x				= 0;
	mouse_old.y				= 0;
	mouse_down_point.x		= 0;
	mouse_down_point.y		= 0;
	sel						= -1;//Is[Xԍ
	timer_on				= FALSE;
//	desk->Reset();
	yukou_num				= 0;
	elap_time				= 0;
	start_time				= 0;
	cur_time				= 0;
	end_img.Reset();
	end_rect.left			= 0;
	end_rect.top			= 0;
	end_rect.right			= 0;
	end_rect.bottom			= 0;
	end_dx					= 0;//̉摜𒆉Ɉړړʁi0͈ړς݁j
	end_dy					= 0;//̉摜𒆉Ɉړړʁi0͈ړς݁j
	seiretu_rect0.left		= 0;
	seiretu_rect0.top		= 0;
	seiretu_rect0.right		= 0;
	seiretu_rect0.bottom	= 0;
	seiretu_rect1.left		= 0;
	seiretu_rect1.top		= 0;
	seiretu_rect1.right		= 0;
	seiretu_rect1.bottom	= 0;
	seiretu_bmp1.Reset();
	seiretu_bmp2.Reset();
	seiretu_L				= 0.0;
	seiretu_H				= 0.0;
	seiretu_S				= 0.0;
	seiretu_b				= 0;
	joint					= FALSE;
	guide_term();
	DK.ResetBackImg();
	DK.Clear();
	InvalidateRect(hWnd, NULL, FALSE);
	if (ini.seiretu==TRUE)
		SetWindowText(hWnd, "ezjig <񃂁[h>");
	else
		SetWindowText(hWnd, "ezjig");
	KillTimer(hWnd, TIMER_PLAY);
}

void GAME::Start(char *image_fname, char *mask_fname)
{
	int		w1, h1, w2, h2, wnum, hnum;
	MYBIT	temp;

	HINSTANCE	hInst= (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);

	Reset();
	lstrcpy(img_fname, image_fname);
	if (lstrcmpi(image_fname+lstrlen(image_fname)-4, ".ezj")==0) {//ff[^
		Load(image_fname);
		DK.SetBackImg(&image);
		DisplayAll();
		if (ini.guide==TRUE) {
			guide_init(hInst, hWnd, &image);
		}
		start_time	= GetTickCount();
		cur_time	= start_time;
		DisplayTitle();
		SetTimer(hWnd, TIMER_PLAY, 1000, NULL);
		return;
	}
	else
	if (mask_fname==NULL) {//}XNȂiʏ̃s[X쐬j
		Start_msk_nasi(image_fname);
	}
	else {//nɍ̐Ńs[Xꍇ
		if (ini.pi_size==0)
			image.ReadDIB(image_fname, hInst);//image
		else
			image.ReadDIBS(image_fname, hInst, ini.pi_size);//image
		mask.ReadDIB(mask_fname, hInst);//mask
		w1	= mask.GetW();
		h1	= mask.GetH();
		w2	= w1 - (w1 % 2);
		h2	= h1 - (h1 % 2);
		if (w1!=w2 || h1!=h2) {
			temp.Cut(&mask, 0, 0, w2, h2);//̑傫ɂ
			mask.Copy(&temp);
		}
		w1		= image.GetW();
		h1		= image.GetH();
		w2		= mask.GetW();
		h2		= mask.GetH();
		wnum	= (w1 * 2) / w2;
		hnum	= (h1 * 2) / h2;
		if (wnum>1 && hnum>1)
			Start_msk_ari1(w1, h1, w2, h2, wnum, hnum);	//}XN^Cɕ~l߂
		else
			Start_msk_ari2(w1, h1, w2, h2);	//̒؂
	}

	DK.SetBackImg(&image);
	DK.Clear();						//	ʂwiŃNA
	disp_piece_no	= 0;			//	\ς݂̃s[X
	CP.Mask1(&image, &mask, &P);	//Mask1Mask2Mask2...Mask3Create1Create2Create2...Create3
	if (ini.guide==TRUE) {
		guide_init(hInst, hWnd, &image);
	}
	koukaon.wait();
}

void GAME::Start_msk_nasi(char *image_fname)
{
	BZ		*bzt;
	int		w1, h1, w2, h2, w3, h3;
	MYBIT	temp;
	int		num;

	HINSTANCE	hInst= (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);

	if (ini.pi_size==0)
		temp.ReadDIB(image_fname, hInst);//imageiLkȂ̏ꍇj
	else
		temp.ReadDIBS(image_fname, hInst, ini.pi_size);//imagei傫w肠̏ꍇj
	w1	= temp.GetW();
	h1	= temp.GetH();
	w2	= w1 * 2;							//]̑傫A}XN͂Q{̑傫
	h2	= h1 * 2;							//]̑傫A}XN͂Q{̑傫
	num	= ini.pi_num;						//]̐
	bzt	= bzline_init(num, w2, h2, ini.seiretu, seiretu_rect0, seiretu_rect1);		//A傫m肷AbztɃxWGȐ̃f[^
	mask.Clear(RGB(255,255,255), w2, h2);
	mask.BZline(bzt, RGB(0,0,0));			//bztɓĂf[^ŃxWGȐ`
	delete []bzt;
	w3	= w2 / 2;							//̓}XN̔
	h3	= h2 / 2;							//̓}XN̔
	image.Cut(&temp, (w1-w3)/2, (h1-h3)/2, w3, h3);		//̒قǂ؂
}

void GAME::Start_msk_ari1(int w1, int h1, int w2, int h2, int wnum, int hnum)
{
	MYBIT	temp;
	int		x, y;

	temp.Copy(&mask);
	mask.Resize(w2*wnum, h2*hnum);
	for (y=0; y<h2*hnum; y+=h2) {
		for (x=0; x<w2*wnum; x+=w2) {
			mask.Paste(&temp, x, y);
		}
	}
	w2		= mask.GetW();
	h2		= mask.GetH();
	w2		= w2 / 2;
	h2		= h2 / 2;

	temp.Copy(&image);
	image.Cut(&temp, (w1-w2)/2, (h1-h2)/2, w2, h2);		//̒قǂ؂
}

void GAME::Start_msk_ari2(int w1, int h1, int w2, int h2)
{
	int		w3, h3;
	MYBIT	temp;
	float	ritu1, ritu2;

	w2		= w2 / 2;
	h2		= h2 / 2;
	if (w1!=w2 || h1!=h2) {
		ritu1	= (float)w1 / (float)h1;
		ritu2	= (float)w2 / (float)h2;
		if (ritu1<ritu2) {
			w3	= w2;
			h3	= h1 * w2 / w1;
		}
		else {
			h3	= h2;
			w3	= w1 * h2 / h1;
		}
		temp.Stretch(&image, w3, h3);
		image.Cut(&temp, (w3-w2)/2, (h3-h2)/2, w2, h2);		//̒قǂ؂
	}
}

void GAME::Mask2()
{
	CP.Mask2();
}

void GAME::Mask3()
{
	CP.Mask3();
}

void GAME::Create1()
{
	CP.Create1();
}

void GAME::Create2()
{
	CP.Create2();
	//\ʒuA]pxA\ԂZbg
	if (ini.seiretu==TRUE) {
		P.Seiretu(disp_piece_no);//񎞂͉]Ȃŕׂ
	}
	else {
		P.RandomOdr(disp_piece_no, ini.pi_kaiten, ini.pi_hanten, hWnd);
	}
	//\
	desk->PasteA(P.GetImgOdr(disp_piece_no), P.GetPosOdr(disp_piece_no));
	InvalidateRect(hWnd, NULL, FALSE);
	PostMessage(hWnd, WM_PAINT, 0, 0);
	disp_piece_no++;
}

void GAME::Create3()
{
	CP.Create3();
}

void GAME::CreateEnd()
{
	//񎞂̓fXNgbv̑傫𖳎ĕKvȑ傫̃LoXɂׂĂ`
	if (ini.seiretu==TRUE && seiretu_rect0.right!=0) {
		seiretu_bmp1.Resize(seiretu_rect0.right, seiretu_rect0.bottom);
		for (int i=0; i<P.GetNum(); i++) {
			seiretu_bmp1.PasteA(P.GetImgOdr(i), P.GetPosOdr(i));
		}
		seiretu_bmp2.Copy(&seiretu_bmp1);
		DK.Clear();//ʂwiŃNA
		desk->Paste(&seiretu_bmp1, 0, 0);
		InvalidateRect(hWnd, NULL, FALSE);
	}
	//Q[Jn
	SetForegroundWindow(hWnd);
	start_time	= GetTickCount();
	cur_time	= start_time;
	yukou_num	= P.GetCurNum();
	DisplayTitle();
	SetTimer(hWnd, TIMER_PLAY, 1000, NULL);
}

void GAME::ReStart()
{
	if (IsBusy())
		return;

	KillTimer(hWnd, TIMER_PLAY);
	if (ini.seiretu==TRUE) {
		for (int i=0; i<P.GetNum(); i++) {
			P.Seiretu(i);
		}
	}
	else {
		for (int i=0; i<P.GetNum(); i++) {
			P.RandomOdr(i, ini.pi_kaiten, ini.pi_hanten, hWnd);
		}
	}
	DisplayAll();
	start_time	= GetTickCount();
	cur_time	= start_time;
	yukou_num	= P.GetCurNum();
	DisplayTitle();
	InvalidateRect(hWnd, NULL, FALSE);
	SetTimer(hWnd, TIMER_PLAY, 1000, NULL);
}

void GAME::ButtonDown(UINT msg, WPARAM wParam, LPARAM lParam)
{
	if (wParam==0) nop();//gpȂ̃[jO߂̖ʂȃR[fBO

	if (CP.GetStep()==3) {
		if (msg==WM_LBUTTONDOWN)	mouse_button	|= 0x80;
		if (msg==WM_RBUTTONDOWN)	mouse_button	|= 0x40;
		if (msg==WM_MBUTTONDOWN)	mouse_button	|= 0x20;
		if (timer_on==FALSE) {
			mouse.x	= GET_X_LPARAM(lParam);
			mouse.y	= GET_Y_LPARAM(lParam);
			sel = P.SelCheck(mouse);
			if (sel>=0) {
				mouse_old	= mouse;
				timer_on	= TRUE;
				SetTimer(hWnd, TIMER_MOUSE, 300, NULL);
			}
		}
		mouse_down_point.x	= GET_X_LPARAM(lParam);
		mouse_down_point.y	= GET_Y_LPARAM(lParam);
	}
}

void GAME::ButtonUp(UINT msg, WPARAM wParam, LPARAM lParam)
{
	if (msg==0) nop();//gpȂ̃[jO߂̖ʂȃR[fBO
	if (wParam==0) nop();//gpȂ̃[jO߂̖ʂȃR[fBO
	if (lParam==0) nop();//gpȂ̃[jO߂̖ʂȃR[fBO

	if (timer_on==TRUE) {
		KillTimer(hWnd, TIMER_MOUSE);
		timer_on	= FALSE;
		sel			= P.Select(sel);
		if (mouse_button==0x80 || mouse_button==0x40) {
			if (ini.pi_kaiten==TRUE)
				sel			= P.Rotate(sel, mouse_old, mouse_button);//]
		}
		else {
			if (ini.pi_hanten==TRUE)
				sel			= P.Rotate(sel, mouse_old, mouse_button);//]
		}
		InvalidateRect(hWnd, NULL, FALSE);
	}
	if (sel>=0) {
		joint = P.JointCheck();
		sel		= -1;
		if (P.GetCurNum()==1) {
			KillTimer(hWnd, TIMER_PLAY);
			DisplayTitle();
			InvalidateRect(hWnd, NULL, FALSE);
			ending_1();
			if (lstrcmpi(img_fname+lstrlen(img_fname)-4, ".ezj")==0) {//ff[^
				DeleteFile(img_fname);
			}
		}
		else {
			DisplayTitle();
			InvalidateRect(hWnd, NULL, FALSE);
		}
	}
	else if (Ended() && end_dx==0 && end_dy==0) {
		FileOpen();//INbNňꗗ\
	}
	mouse_button	= 0;
}

void GAME::MouseMove(UINT msg, WPARAM wParam, LPARAM lParam)
{
	if (msg==0) nop();//gpȂ̃[jO߂̖ʂȃR[fBO

	if (CP.GetStep()!=3)
		return;

	if (timer_on==TRUE) {
		KillTimer(hWnd, TIMER_MOUSE);
		timer_on	= FALSE;
		sel			= P.Select(sel);
	}
	if (wParam&MK_LBUTTON || wParam&MK_RBUTTON || wParam&MK_MBUTTON) {
		mouse.x	= GET_X_LPARAM(lParam);
		mouse.y	= GET_Y_LPARAM(lParam);
		if (GetAsyncKeyState(VK_CONTROL)&0x80000) {
			P.MMove(mouse_down_point, mouse);
			mouse_down_point	= mouse;
			InvalidateRect(hWnd, NULL, FALSE);
		}
		else
		if (sel>=0) {
			P.Move(mouse.x-mouse_old.x, mouse.y-mouse_old.y);
			mouse_old	= mouse;
			InvalidateRect(hWnd, NULL, FALSE);
		}
	}
}

void GAME::TimeOut(UINT msg, WPARAM wParam, LPARAM lParam)
{
	if (msg==0) nop();//gpȂ̃[jO߂̖ʂȃR[fBO
	if (lParam==0) nop();//gpȂ̃[jO߂̖ʂȃR[fBO

	if (wParam==TIMER_MOUSE) {//܂܂̂Ƃ
		if (timer_on==TRUE) {
			KillTimer(hWnd, TIMER_MOUSE);
			timer_on	= FALSE;
			sel			= P.Select(sel);
			InvalidateRect(hWnd, NULL, FALSE);
		}
	}
	else
	if (wParam==TIMER_PLAY) {//oߎ
		cur_time	= GetTickCount();
		DisplayTitle();
	}
	else
	if (wParam==TIMER_END) {//GfBO
		ending_2();
	}
}

void GAME::Space(POINT mouse)
{
	int		s;

	s = P.SelCheck(mouse);
	if (s>=0) {
		P.Separate(s);
		InvalidateRect(hWnd, NULL, FALSE);
	}
}

void GAME::Paint(UINT msg, WPARAM wParam, LPARAM lParam)
{
	if (msg==0) nop();//gpȂ̃[jO߂̖ʂȃR[fBO
	if (wParam==0) nop();//gpȂ̃[jO߂̖ʂȃR[fBO
	if (lParam==0) nop();//gpȂ̃[jO߂̖ʂȃR[fBO

	HDC				hDC;
	PAINTSTRUCT		p_str;

	TRACE((s,"GAME::Paint(BEGIN)"))
	hDC = BeginPaint(hWnd, &p_str);			/*HDCƍĕ`͈͂擾*/
	desk->Display(0, 0, hDC);
	EndPaint(hWnd, &p_str);
	TRACE((s,"GAME::Paint(END)"))
	if (joint==TRUE) {
		koukaon.joint();
		joint = FALSE;
	}
}

BOOL GAME::IsBusy()
{
	if (CP.GetStep()==1 || CP.GetStep()==2)
		return(TRUE);
	else
		return(FALSE);
}

BOOL GAME::Playing()	//Q[ȂTRUE
{
	if (CP.GetStep()==3 && P.GetCurNum()!=1)	//s[XŃs[XP傫
		return(TRUE);
	else
		return(FALSE);
}

BOOL GAME::Ended()		//WO\[pYȂTRUE
{
	if (CP.GetStep()==3 && P.GetCurNum()==1)	//s[XŃs[XP܂芮
		return(TRUE);
	else
		return(FALSE);
}

void GAME::DisplayAll()
{
	RECT	r;

	DK.Clear();
	if (P.GetNum()>0) {
		r.left		= 0;
		r.top		= 0;
		r.right		= desk->GetW();
		r.bottom	= desk->GetH();
		P.Display(r, 0, P.GetNum()-1);
	}
	InvalidateRect(hWnd, NULL, FALSE);
}

void GAME::SaveTopPiece(char *fname)
{
	P.GetImgOdr(P.GetNum()-1)->WriteDIB(fname);
}

void GAME::Save(BOOL message)		//fo
{
	if (IsBusy())
		return;

	KillTimer(hWnd, TIMER_PLAY);
	elap_time	= cur_time - start_time;

	char	wfname[MAX_PATH];
	int		i;
	lstrcpy(wfname, img_fname);
	for (i=lstrlen(wfname)-1; wfname[i]!='.'; i--)//gq̈ʒuT
		;
	wfname[i]	= '\0';
	lstrcat(wfname, ".ezj");//gq.ezjɕύX
	P.Save(wfname, &image, &yukou_num, &elap_time);

	if (message==TRUE) {
		char	str[1000];
		wsprintf(str, "ۑ܂B\n%s", wfname);
		MessageBox(NULL, str, "ezjig",MB_OK);
	}
}

void GAME::Load(char *fname)	//f
{
	P.Load(fname, &image, &yukou_num, &elap_time);
	mouse_button	= 0;
	sel				= -1;
	CP.SetStep(3);
}

void GAME::DisplayTitle()
{
	char	text[200];
	int		hh, mm, ss, n;

	ss	= ( elap_time + cur_time - start_time) / 1000;
	mm	= ss / 60;
	ss	= ss % 60;
	hh	= mm / 60;
	mm	= mm % 60;
	n	= P.GetCurNum();
	if (n>1)
		wsprintf(text, "ezjig %02d:%02d:%02d c%d߰(S%d߰)", hh, mm, ss, n, yukou_num);
	else
		wsprintf(text, "ezjig %02d:%02d:%02d (^o^)(^o^) (S%d߰)", hh, mm, ss, yukou_num);
	SetWindowText(hWnd, text);
}

void GAME::ending_1()
{
	RECT	r1, r2;
	int		w1, h1, w2, h2, i;

	P.GetEndImg(&end_img, &r1);
	w1				= r1.right  - r1.left;
	h1				= r1.bottom - r1.top;
	GetClientRect(hWnd, &r2);
	w2				= r2.right  - r2.left;
	h2				= r2.bottom - r2.top;
	if (w1<=w2 && h1<=h2) {
		end_rect.left	= (w2 - w1) / 2;
		end_rect.top	= (h2 - h1) / 2;
		end_rect.right	= end_rect.left + w1;
		end_rect.bottom	= end_rect.top  + h1;
		end_dx			= r1.left - end_rect.left;
		end_dy			= r1.top  - end_rect.top;
	}
	else {
		end_rect.left	= r1.left;
		end_rect.top	= r1.top;
		end_rect.right	= r1.right;
		end_rect.bottom	= r1.bottom;
		end_dx			= 0;
		end_dy			= 0;
	}
	P.AddRect(end_dx, end_dy, 0, P.GetNum()-1);
	SetTimer(hWnd, TIMER_END, 10, NULL);
}

void GAME::ending_2()
{
	if (end_dx==0 && end_dy==0) {
		KillTimer(hWnd, TIMER_END);
		ending_3(0.0, 0.0, 0.0, 0.0, 0);
		return;
	}
	if (end_dx>0)	end_dx-=4;
	if (end_dx<0)	end_dx+=4;
	if (end_dy>0)	end_dy-=4;
	if (end_dy<0)	end_dy+=4;
	if (end_dx<4 && end_dx>-4)
		end_dx	= 0;
	if (end_dy<4 && end_dy>-4)
		end_dy	= 0;
	DK.Clear();
	desk->Paste(&end_img, end_rect.left+end_dx, end_rect.top+end_dy);
	InvalidateRect(hWnd, NULL, FALSE);
}

void GAME::ending_3(double L1, double L2, double H, double S, int t)	//摜ɘgt
{
	int			i, x1, y1, x2, y2, w, h;
	double		L;
	COLORREF	c;
	MYBIT		temp;

	ini.end_waku_L1	+= L1;
	ini.end_waku_L2	+= L2;
	ini.end_waku_H	+= H;
	if (ini.end_waku_H>100.0)
		ini.end_waku_H	= 0.0;
	if (ini.end_waku_H<0.0)
		ini.end_waku_H	= 100.0;
	ini.end_waku_S	+= S;
	if (ini.end_waku_S>100.0)
		ini.end_waku_S	= 100.0;
	if (ini.end_waku_S<0.0)
		ini.end_waku_S	= 0.0;
	ini.end_waku_t	+= t;
	if (ini.end_waku_t<2)
		ini.end_waku_t	= 2;

	L1	= ini.end_waku_L1;
	L2	= ini.end_waku_L2;
	H	= ini.end_waku_H;
	S	= ini.end_waku_S;
	t	= ini.end_waku_t;

	w	= end_rect.right  - end_rect.left;
	h	= end_rect.bottom - end_rect.top;
	temp.Resize(w+t+t, h+t+t);
	temp.Paste(&end_img, t, t);
	//̘g
	x1	= 0;
	y1	= 0;
	x2	= w + t + t;
	y2	= y1;
	for (i=0; i<t; i++) {
		L	= (L2 - L1) * (double)(t-1-i) / (double)(t-1) + L1;
		c	= LHStoRGBx(L, H, S);
		temp.Line(x1, y1, x2, y2, c);
		x1++;
		y1++;
		x2--;
		y2++;
	}
	//̘g
	x1	= 0;
	y1	= h + t + t - 1;
	x2	= w + t + t;
	y2	= y1;
	for (i=0; i<t; i++) {
		L	= (L2 - L1) * (double)i / (double)(t-1) + L1;
		c	= LHStoRGBx(L, H, S);
		temp.Line(x1, y1, x2, y2, c);
		x1++;
		y1--;
		x2--;
		y2--;
	}
	//̘g
	x1	= 0;
	y1	= 0;
	x2	= x1;
	y2	= h + t + t;
	for (i=0; i<t; i++) {
		L	= (L2 - L1) * (double)(t-1-i) / (double)(t-1) + L1;
		c	= LHStoRGBx(L, H, S);
		temp.Line(x1, y1, x2, y2, c);
		x1++;
		y1++;
		x2++;
		y2--;
	}
	//E̘g
	x1	= w + t + t - 1;
	y1	= 0;
	x2	= x1;
	y2	= h + t + t;
	for (i=0; i<t; i++) {
		L	= (L2 - L1) * (double)i / (double)(t-1) + L1;
		c	= LHStoRGBx(L, H, S);
		temp.Line(x1, y1, x2, y2, c);
		x1--;
		y1++;
		x2--;
		y2--;
	}
	DK.Clear();
	desk->Paste(&temp, end_rect.left-t, end_rect.top-t);
	InvalidateRect(hWnd, NULL, FALSE);
	koukaon.end();
}

void GAME::seiretu_write()
{
	MYBIT	temp;
	int		w, h;
	w	= seiretu_rect1.right  - seiretu_rect1.left;
	h	= seiretu_rect1.bottom - seiretu_rect1.top;
	temp.Resize(w, h);
	temp.Cut(&seiretu_bmp2, seiretu_rect1.left, seiretu_rect1.top, w, h);
	temp.WriteDIB((char*)"seiretu.bmp");
	seiretu_bmp2.WriteDIB((char*)"seiretu_all.bmp");
	MessageBox(hWnd, "seiretu.bmp֏o͂܂B\nŜseiretu_all.bmp֏o͂܂B", "ezjig", MB_OK);
}

void GAME::seiretu_modify(double dL, double dH, double dS, BOOL bokasi)
{
	double		L, H, S;
	int			i, x, y, h, w, n, R, G, B, dx, dy;
	COLORREF	*p1, *p2;

	seiretu_L	+= dL;
	seiretu_H	+= dH;
	seiretu_S	+= dS;
	if (bokasi==TRUE)	seiretu_b++;

	p1	= seiretu_bmp1.GetC();
	p2	= seiretu_bmp2.GetC();
	for (i=0; i<seiretu_bmp1.GetSize(); i++) {
		RGBtoLHS(p1[i], &L, &H, &S);
		L	+= seiretu_L;
		H	+= seiretu_H;
		S	+= seiretu_S;
		p2[i] = LHStoRGB(L, H, S);
	}
	w	= seiretu_bmp1.GetW();
	h	= seiretu_bmp1.GetH();
	for (n=0; n<seiretu_b; n++) {
		MYBIT	temp;
		temp.Copy(&seiretu_bmp2);
		p1	= seiretu_bmp2.GetC();
		p2	= temp.GetC();
		for (y=1; y<h-1; y++) {
			for (x=1; x<w-1; x++) {
				R	= 0;
				G	= 0;
				B	= 0;
				for (dy=-1; dy<2; dy++) {
					for (dx=-1; dx<2; dx++) {
						R	+= GetRValue(p1[(x+dx) + (y+dy)*w]);
						G	+= GetGValue(p1[(x+dx) + (y+dy)*w]);
						B	+= GetBValue(p1[(x+dx) + (y+dy)*w]);
					}
				}
				p2[x+y*w]	= RGB(R/9, G/9, B/9);
			}
		}
		seiretu_bmp2.Copy(&temp);
	}
	desk->Paste(&seiretu_bmp2, 0, 0);
	InvalidateRect(hWnd, NULL, FALSE);
}

