// game.h
#ifndef GAME_H
#define GAME_H

#include <windows.h>
#include <windowsx.h>
#include "mybit.h"
#include "create.h"
#include "piece.h"

class GAME {
	HWND			hWnd;
	int				view_sel_no_image;
	int				view_sel_no_mask;
	char			img_fname[MAX_PATH];
	CREATE			CP;				//s[X쐬
	PIECES			P;				//s[X
	MYBIT			image;
	MYBIT			mask;
	int				disp_piece_no;	//\ς݂̃s[X
	BYTE			mouse_button;
	POINT			mouse;
	POINT			mouse_old;
	POINT			mouse_down_point;
	int				sel;
	BOOL			timer_on;
	MYBIT			*desk;
	int				yukou_num;//ȃs[XOs[X
	int				elap_time;
	DWORD			start_time;
	DWORD			cur_time;
	MYBIT			end_img;
	RECT			end_rect;
	int				end_dx;
	int				end_dy;
	RECT			seiretu_rect0;//S
	RECT			seiretu_rect1;//pڂ̂Ȃ摜ɂȂ钆
	MYBIT			seiretu_bmp1;//HO
	MYBIT			seiretu_bmp2;//H
	double			seiretu_L;
	double			seiretu_H;
	double			seiretu_S;
	int				seiretu_b;
	BOOL			joint;
private:
	void	Start_msk_nasi	(char *image_fname);
	void	Start_msk_ari1	(int w1, int h1, int w2, int h2, int wnum, int hnum);
	void	Start_msk_ari2	(int w1, int h1, int w2, int h2);
public:
	GAME				();
	~GAME				();
	void	Init		(HWND hWnd);
	void	FileOpen	();
	void	FileSelect	(WPARAM wParam, LPARAM lParam);
	void	FileDrop	(WPARAM wParam);
	void	Reset		();
	void	Start		(char *image_fname, char *mask_fname);
	void	Mask2		();
	void	Mask3		();
	void	Create1		();
	void	Create2		();
	void	Create3		();
	void	CreateEnd	();
	void	ReStart		();
	void	ButtonDown	(UINT msg, WPARAM wParam, LPARAM lParam);
	void	ButtonUp	(UINT msg, WPARAM wParam, LPARAM lParam);
	void	MouseMove	(UINT msg, WPARAM wParam, LPARAM lParam);
	void	TimeOut		(UINT msg, WPARAM wParam, LPARAM lParam);
	void	Space		(POINT mouse);
	void	Paint		(UINT msg, WPARAM wParam, LPARAM lParam);
	BOOL	IsBusy		();
	BOOL	Playing		();
	BOOL	Ended		();
	void	DisplayAll	();//Ss[Xĕ\
	void	SaveTopPiece(char *fname);
	void	Save		(BOOL message=TRUE);
	void	Load		(char *fname);
	MYBIT*	GetImgPtr	()	{return(&image);}
	void	DisplayTitle();
	void	ending_1	();
	void	ending_2	();
	void	ending_3	(double L1, double L2, double H, double S, int t);
	void	seiretu_write();
	void	seiretu_modify(double dL, double dH, double dS, BOOL bokasi);
};

#endif /*GAME_H*/
