// ini.cpp

#define INI_CPP

#include <windows.h>
#include <stdlib.h>
#include "ini.h"

void set_dir_1()
{
	LPTSTR	cmdline;
	char	str[MAX_PATH];
	char	s_drive     [_MAX_DRIVE];
	char	s_dir       [_MAX_DIR];
	char	s_name      [_MAX_FNAME];
	char	s_ext       [_MAX_EXT];

	cmdline		= GetCommandLine();//R}hC擾
	if (cmdline[0]=='"') {
		lstrcpy(str, cmdline+1);
		str[lstrlen(str)-1]	= '\0';
	}
	else
		lstrcpy(str, cmdline);
	_splitpath(str, s_drive, s_dir, s_name, s_ext);//R}hC̗vfo

	lstrcpy(ini.exe_dir, s_drive);
	lstrcat(ini.exe_dir, s_dir);
	if (ini.exe_dir[lstrlen(ini.exe_dir)-1]=='\\')
		ini.exe_dir[lstrlen(ini.exe_dir)-1]='\0';

	lstrcpy(ini.ini_fname, ini.exe_dir);
	lstrcat(ini.ini_fname, "\\ezjig.ini");
}

void set_dir_2()
{
	lstrcpy(ini.mask_dir, ini.exe_dir);
	lstrcat(ini.mask_dir, "\\pattern");

	lstrcpy(ini.program_dir, ini.exe_dir);
	lstrcat(ini.program_dir, "\\program");

	lstrcpy(ini.sound_dir, ini.exe_dir);
	lstrcat(ini.sound_dir, "\\program\\source");

	lstrcpy(ini.img_dir, ini.exe_dir);
	lstrcat(ini.img_dir, "\\image");

	lstrcpy(ini.back_dir, ini.exe_dir);
	lstrcat(ini.back_dir, "\\back");
}

void read_ini(init_struct &ini)
{
    HANDLE	hFile;
	DWORD	accbyte;

	set_dir_1();
	hFile = CreateFile(ini.ini_fname, GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile!=INVALID_HANDLE_VALUE) {
		ReadFile(hFile, &ini, sizeof(init_struct), &accbyte, NULL);
	    CloseHandle(hFile);
	}
	set_dir_2();
}

void write_ini(init_struct &ini)
{
    HANDLE	hFile;
	DWORD	accbyte;

	DeleteFile(ini.ini_fname);
    hFile = CreateFile(ini.ini_fname, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
    WriteFile(hFile, &ini, sizeof(init_struct), &accbyte, NULL);
    CloseHandle(hFile);
}

void write_ini_txt(init_struct &ini, char *fname)	//ini\̂̓emFifobOpj
{
    HANDLE	hFile;
	DWORD	accbyte;
	char	s[1000];
	int		i, j;

	DeleteFile(fname);
    hFile = CreateFile(fname, GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	for (i=0; i<LINE_INITIAL_MAX_1; i++) {
		lstrcpy(s, "line_initial={");
		WriteFile(hFile, s, lstrlen(s), &accbyte, NULL);
		for (j=0; j<LINE_INITIAL_MAX_2; j++) {
			wsprintf(s, "{%d,%d},", ini.line_initial[i][j].x, ini.line_initial[i][j].y);
			WriteFile(hFile, s, lstrlen(s), &accbyte, NULL);
		}
		lstrcpy(s, "}\n");
		WriteFile(hFile, s, lstrlen(s), &accbyte, NULL);
	}
	wsprintf(s, "end_waku_L1=%d / 100\n", (int)(ini.end_waku_L1*100));
	WriteFile(hFile, s, lstrlen(s), &accbyte, NULL);
	wsprintf(s, "end_waku_L2=%d / 100\n", (int)(ini.end_waku_L2*100));
	WriteFile(hFile, s, lstrlen(s), &accbyte, NULL);
	wsprintf(s, "end_waku_H=%d / 100\n", (int)(ini.end_waku_H*100));
	WriteFile(hFile, s, lstrlen(s), &accbyte, NULL);
	wsprintf(s, "end_waku_S=%d / 100\n", (int)(ini.end_waku_S*100));
	WriteFile(hFile, s, lstrlen(s), &accbyte, NULL);
	wsprintf(s, "end_waku_t=%d\n", ini.end_waku_t);
	WriteFile(hFile, s, lstrlen(s), &accbyte, NULL);
	wsprintf(s, "edge_thick=%d\n", ini.edge_thick);
	WriteFile(hFile, s, lstrlen(s), &accbyte, NULL);
	wsprintf(s, "edge_light=%d\n", ini.edge_light);
	WriteFile(hFile, s, lstrlen(s), &accbyte, NULL);
    CloseHandle(hFile);
}

