

#define _TRACE_OFF_


#include <windows.h>
#include <math.h>
#include "ezjig.h"
#include "create.h"
#include "ini.h"
#include "prog.h"

extern HWND main_hWnd;

#define c_white		RGB(255,255,255)
#define c_black		RGB(000,000,000)
#define c_green		RGB(000,255,000)
#define c_blue		0x000000ff

CREATE::CREATE()
{
	pP			= NULL;
	mask_w		= 0;
	mask_h		= 0;
	num			= 0;
	step		= 0;
	thick		= 0;
	Mask_y		= 0;
	Mask_c1		= NULL;
	Create_i	= 0;
}

CREATE::~CREATE()
{
}

void CREATE::Reset()
{
	int		i;

	mask.Reset();
	image.Reset();
	if (pP!=NULL)
		pP->Reset();
	pP			= NULL;
	mask_w		= 0;
	mask_h		= 0;
	num			= 0;
	step		= 0;
	for (i=0; i<10000; i++) {
		msk_rect[i].left	= 0;
		msk_rect[i].right	= 0;
		msk_rect[i].top		= 0;
		msk_rect[i].bottom	= 0;
		msk[i].Reset();
	}
	thick		= 0;
	Mask_y		= 0;
	Mask_c1		= NULL;
	Create_i	= 0;
}

void CREATE::Mask1(MYBIT *imgs, MYBIT *msks, PIECES *pp)
{
	if (imgs->GetW()*2 != msks->GetW() || imgs->GetH()*2 != msks->GetH())
		MessageBox(NULL,"}XN̑傫̂Q{łȂ","",MB_OK);

	Reset();
	mask.Copy(msks);
	image.Copy(imgs);
	pP			= pp;
	mask_w		= mask.GetW();
	mask_h		= mask.GetH();
	step		= 1;
	prog_create(main_hWnd, (HINSTANCE)GetWindowLong(main_hWnd, GWL_HINSTANCE), 0, 0, 200, 20, mask_h);
	prog_back_color(RGB(176,248,129));
	prog_bar_color(RGB(94,215,13));
	Mask_c1		= mask.GetC();
	Mask_y		= mask_h - 1;
	PostMessage(main_hWnd, MSG_MASK2, 0, 0);//Mask2()bZ[WŋN
}

//msks͔nɍ̂̕ł邱
void CREATE::Mask2()
{
	int			x, y, i, wh;
	COLORREF	cc, rgb;

	y	= Mask_y;
	for (x=0; x<mask_w; x++) {
		cc	= *Mask_c1;
		if (cc==c_white) {
			rgb	= num + 1;
			rgb	= RGB(GetBValue(rgb), GetGValue(rgb), GetRValue(rgb));//FillBprgbl̊i[ύX(RGBBGR)
			mask.FillB(x, y, rgb,  c_black);
			msk_rect [num].left		= x;
			msk_rect [num].top		= y;
			msk_rect [num].right	= x;
			msk_rect [num].bottom	= y;
			num++;
		}
		else if (cc==c_black) {
			;
		}
		else {
			i	= cc - 1;
			if (x<msk_rect[i].left)		msk_rect[i].left	= x;
			if (y<msk_rect[i].top)		msk_rect[i].top		= y;
			if (x>msk_rect[i].right)	msk_rect[i].right	= x;
			if (y>msk_rect[i].bottom)	msk_rect[i].bottom	= y;
		}
		Mask_c1++;
	}
	prog_up();

	Mask_y--;
	if (Mask_y>=0)
		PostMessage(main_hWnd, MSG_MASK2, 0, 0);//Mask2()bZ[WŋN
	else
		PostMessage(main_hWnd, MSG_MASK3, 0, 0);//Mask3()bZ[WŋN
}

void CREATE::Mask3()
{
	int		i, wh;

	prog_close();
	//݂̌
	wh	= 0;
	for (i=0; i<num; i++) {
		wh	= wh + (msk_rect[i].right  - msk_rect[i].left);
		wh	= wh + (msk_rect[i].bottom - msk_rect[i].top);
	}
	wh	= wh / (num * 2);
	if (wh>100)
		wh	= 100;
	thick	= ini.edge_thick * wh / 100;
	if (thick<3)
		thick	= 3;
	PostMessage(main_hWnd, MSG_CREATE1, 0, 0);//CREATE1()bZ[WŋN
}

void CREATE::Create1()
{
	int		i, j;

	step	= 2;
	if (ini.seiretu==TRUE) {
		for (i=0; i<num; i++) {
			pP->SetOdr(i, i);
		}
	}
	else {
		srand(GetTickCount());
		for (i=0; i<num; i++) {
			j = rand() % num;
			while (1) {
				if (pP->GetOdr(j)<0) {
					pP->SetOdr(j, i);
					break;
				}
				j++;
				if (j>=num)
					j	= 0;
			}
		}
	}
	prog_create(main_hWnd, (HINSTANCE)GetWindowLong(main_hWnd, GWL_HINSTANCE), 0, 0, 200, 20, num);
	prog_back_color(RGB(129,244,248));
	prog_bar_color(RGB(12,210,216));
	Create_i	= 0;
	PostMessage(main_hWnd, MSG_CREATE2, 0, 0);//CREATE2()bZ[WŋN
}

//s[X
void CREATE::Create2()
{
	int		j;

	j	= pP->GetOdr(Create_i);
	Separate(j);
	PieceImage(j);
	pP->SetInitV(j, j, 0);//nojoint,mukiZbg
	pP->SetNum(Create_i+1);
	prog_up();

	Create_i++;
	if (Create_i<num)
		PostMessage(main_hWnd, MSG_CREATE2, 0, 0);//CREATE2()bZ[WŋN
	else
		PostMessage(main_hWnd, MSG_CREATE3, 0, 0);//CREATE3()bZ[WŋN
}

void CREATE::Create3()
{
	prog_close();
	SetTonari();
	step	= 3;
	PostMessage(main_hWnd, MSG_CREATE_END, 0, 0);//GAME::CreateEnd()bZ[WŊʒm
}

//msk_rectŐ؂
void CREATE::Separate(int no)
{
	RECT		r;
	COLORREF	*c1;
	COLORREF	c_green_alpha = c_green | 0xff000000;
	int			i;

	r	= msk_rect[no];
	r.left--;										//Phbg傫
	if (r.left  <     0)	r.left   = 0;
	if (r.left  %2 == 1)	r.left--;
	r.top--;										//Phbg傫
	if (r.top   <     0)	r.top    = 0;
	if (r.top   %2 == 1)	r.top--;
	r.right++;										//Phbg傫
	r.right++;										//right=left+width̊֌Wɂ
	if (r.right >mask_w)	r.right  = mask_w;
	if (r.right %2 == 1)	r.right++;
	r.bottom++;										//Phbg傫
	r.bottom++;										//bottom=top+height̊֌Wɂ
	if (r.bottom>mask_h)	r.bottom = mask_h;
	if (r.bottom%2 == 1)	r.bottom++;
	msk_rect[no]	= r;

	//mask؂
	msk[no].Cut(&mask, r.left, r.top, (r.right - r.left), (r.bottom - r.top));

	TRACE((s,"CREATE::Separate(1) no=%d",no))

	//(no+1)F͗΁A͍ɂ
	c1		= msk[no].GetC();
	for (i=0; i<msk[no].GetSize(); i++) {
		if (*c1==(DWORD)(no+1))
			*c1	= c_green_alpha;
		else
			*c1	= c_black;
		c1++;
	}
	TRACE((s,"CREATE::Separate(2)"))
	OutBlue(&msk[no]);
	TRACE((s,"CREATE::Separate END"))
}

//OPgbhɂ
void CREATE::OutBlue(MYBIT *msk)
{
	int			w, h, i;
	MYBIT		temp;
	POINT		p, p0, p1, p2;
	COLORREF	c_green_alpha = c_green | 0xff000000;
	COLORREF	c_blue_alpha  = c_blue  | 0xff000000;
	COLORREF	*c1, *c2;

	w	= msk->GetW();
	h	= msk->GetH();
	temp.Resize(w+2, h+2);
	temp.Paste(msk, 1, 1);
	c1	= temp.GetC();
	for (i=0; i<temp.GetSize(); i++) {
		p1.x	= i % (w+2);
		if (*c1==c_green_alpha && *(c1-1)==c_black) {
			p1.y	= (h+2) - i / (w+2) - 1;
			p		= p1;
			temp.Outside(&p, c_green_alpha, TRUE);
			temp.Outside(&p, c_green_alpha, FALSE);
			temp.Outside(&p, c_green_alpha, FALSE);
			p0	= p;
			while (1) {
				if (temp.Outside(&p, c_green_alpha, FALSE)==TRUE) {
					p2.x	= p.x - 1;
					p2.y	= p.y - 1;
					if (p2.x>=0 && p2.y>=0 && p2.x<w && p2.y<h) {
						c2		= msk->GetC() + (h - p2.y - 1) * w + p2.x;
						*c2		= c_blue_alpha;//OPgbhɂ
					}
				}
				if (p.x==p0.x && p.y==p0.y)
					break;
			}
			temp.FillS(p1.x-1, p1.y, c_blue,  c_black);//ςݕɂ
		}
		c1++;
	}
}

//img\t
void CREATE::PieceImage(int no)
{
	int		j, x, y, w, h;
	MYBIT	wimg[8];
	MYBIT	wmsk[8];
	RECT	r;
	MYBIT	*pimg;

	TRACE((s,"PieceImage(BEGIN)"))
	//}XN̉]A]s
	wmsk[0].Copy    (&(msk[no]));
	wmsk[0].RotateTurn(&(wmsk[1]), &(wmsk[2]), &(wmsk[3]), &(wmsk[4]), &(wmsk[5]), &(wmsk[6]), &(wmsk[7]));
	TRACE((s,"PieceImage(1)"))
	//݂vZāA傫𔼕ɂ
	for (j=0; j<8; j++) {
		wmsk[j].Thick(thick);
		TRACE((s,"CREATE::PieceImage(2-1)"))
//		wmsk[j].Average(2);
		wmsk[j].HalfSize();
		TRACE((s,"CREATE::PieceImage(2-2)"))
	}
	TRACE((s,"CREATE::PieceImage(2END)"))
	//imgs؂oĉ]A]s
	x	=  msk_rect[no].left   / 2;
	y	=  msk_rect[no].top    / 2;
	w	= (msk_rect[no].right  - msk_rect[no].left) / 2;
	h	= (msk_rect[no].bottom - msk_rect[no].top ) / 2;
	r.left		= x;
	r.top		= y;
	r.right		= r.left + w;
	r.bottom	= r.top  + h;
	pP->SetRect(no, r);
	pP->SetOrgRect(no, r);
	wimg[0].Cut     (&image, x, y, w, h);
	wimg[0].RotateTurn(&(wimg[1]), &(wimg[2]), &(wimg[3]), &(wimg[4]), &(wimg[5]), &(wimg[6]), &(wimg[7]));
	TRACE((s,"CREATE::PieceImage(3)"))
	//C[W̓\t
	for (j=0; j<8; j++) {
		pimg	= pP->GetImg(no, j);
		pimg->Combine(&(wimg[j]), &(wmsk[j]));
	}
	TRACE((s,"CREATE::PieceImage(END)"))
}

void CREATE::Sample(MYBIT *img, MYBIT *msk, MYBIT *pimg)
{
	int			x, y, i;
	COLORREF	*c;
	COLORREF	c_green_alpha = c_green | 0xff000000;
	MYBIT		temp;

	temp.Copy(msk);
	x	= temp.GetW() / 2;
	y	= temp.GetH() / 2;
	temp.FillB(x, y, c_green,  c_black);
	c	= temp.GetC();
	for (i=0; i<temp.GetSize(); i++) {
		if (*c==c_green)
			*c	= c_green_alpha;
		else
			*c	= c_black;
		c++;
	}
	OutBlue(&temp);
	temp.Thick(ini.edge_thick);
	temp.HalfSize();
	pimg->Combine(img, &temp);
}

//tonari𔻒
void CREATE::SetTonari()
{
	int			i, j, k, x, y, w, h, n, m;
	COLORREF	*c1, *c2, c_blue_alpha;
	RECT		r1;
	MYBIT		temp1, temp2;
	int			t[10000], *tt;

	TRACE((s,"CREATE::SetTonari(BEGIN)"))
	c_blue_alpha	= c_blue | 0xff000000;
	prog_create(main_hWnd, (HINSTANCE)GetWindowLong(main_hWnd, GWL_HINSTANCE), 0, 0, 200, 20, num);
	prog_back_color(RGB(128,160,249));
	prog_bar_color(RGB(11,67,217));
	for (i=0; i<num; i++) {
		n		= 0;
		t[n]	= -1;
		for (j=0; j<num; j++) {
			IntersectRect(&r1, &msk_rect[i], &msk_rect[j]);//߂
			if (r1.left!=0 || r1.top!=0 || r1.right!=0 || r1.bottom!=0) {
				w	= r1.right  - r1.left;
				h	= r1.bottom - r1.top;
				x	= (r1.left>msk_rect[i].left) ? r1.left - msk_rect[i].left : 0;
				y	= (r1.top >msk_rect[i].top ) ? r1.top  - msk_rect[i].top  : 0;
				temp1.Cut(&msk[i], x, y, w, h);//؂o
				x	= (r1.left>msk_rect[j].left) ? r1.left - msk_rect[j].left : 0;
				y	= (r1.top>msk_rect[j].top  ) ? r1.top  - msk_rect[j].top  : 0;
				temp2.Cut(&msk[j], x, y, w, h);//؂o
				c1		= temp1.GetC();
				c2		= temp2.GetC();
				m		= 0;
				for (k=0; k<temp1.GetSize(); k++) {
					if (*c1==c_blue_alpha && *c2==c_blue_alpha) {
						m++;
						if (m>10)//ʒuɋE10hbg葽ΗדmƔf
							break;
					}
					c1++;	c2++;
				}
				if (m>10) {//ʒuɋE10hbg葽ΗדmƔf
					t[n]	= j;
					t[++n]	= -1;
				}
			}
		}
		tt	= (int*)GlobalAlloc(GMEM_FIXED, (n+1)*sizeof(int));
		CopyMemory (tt, t, (n+1)*sizeof(int));
		pP->SetTonari(i, tt);
		prog_up();
	}
	prog_close();
	TRACE((s,"CREATE::SetTonari(END)"))
}

