#include <stdio.h>
#include <setjmp.h>

#undef  FAR				//d`h~
#define XMD_H			//INT32Ȃǂ̒`h~

#include <jpeglib.h>

void* mem_alloc(int size);//mybit.cppŒ`

struct jpeg_jpeg_error_mgr {
	struct jpeg_error_mgr pub;	/* "public" fields */
	jmp_buf setjmp_buffer;		/* for return to caller */
};

typedef struct jpeg_jpeg_error_mgr * jpeg_jpeg_error_ptr;

METHODDEF(void)
jpeg_jpeg_error_exit (j_common_ptr cinfo)
{
	jpeg_jpeg_error_ptr myerr = (jpeg_jpeg_error_ptr) cinfo->err;
	(*cinfo->err->output_message) (cinfo);
	longjmp(myerr->setjmp_buffer, 1);
}

int jpeg_get_image(char *fname, unsigned long **buf, int *w, int *h, int denom, int check_only)
{
	struct jpeg_decompress_struct	cinfo;
	struct jpeg_jpeg_error_mgr		jerr;
	JSAMPARRAY						buffer;
	int								row_stride, i, j;
	FILE							*fp=NULL;
	unsigned long					*wp1, *wp2;
	unsigned char					R, G, B;

	cinfo.err = jpeg_std_error(&jerr.pub);
	jerr.pub.error_exit = jpeg_jpeg_error_exit;

	if (setjmp(jerr.setjmp_buffer)) {
		jpeg_destroy_decompress(&cinfo);
		fclose(fp);
		return(FALSE);
	}

	jpeg_create_decompress(&cinfo);
	if ((fp=fopen(fname, "rb")) == NULL) {
		return(FALSE);
	}
	jpeg_stdio_src(&cinfo, fp);
	jpeg_read_header(&cinfo, TRUE);

	cinfo.dct_method	= (J_DCT_METHOD)JDCT_IFAST;
//	if (denom>1) {
//		cinfo.scale_num		= 1;
//		cinfo.scale_denom	= 8;//2,4,8̏k
//	}
	cinfo.scale_num		= 1;
	cinfo.scale_denom	= denom;//2,4,8̏k

	jpeg_start_decompress(&cinfo);

	*w		= cinfo.output_width;
	*h		= cinfo.output_height;

	if (check_only==FALSE) {
		*buf	= (unsigned long*)mem_alloc((*w)*(*h)*4);
		wp1		= *buf + (*w)*(*h);

		row_stride	= (*w) * cinfo.output_components;
		buffer		= (*cinfo.mem->alloc_sarray)((j_common_ptr) &cinfo, JPOOL_IMAGE, row_stride, 1);

		for (i=0; i<(*h); i++) {
			jpeg_read_scanlines(&cinfo, buffer, 1);
			wp1 = wp1 -  (*w);
			wp2 = wp1;
			for (j=0; j<row_stride; j=j+3) {
				R = (unsigned char)buffer[0][j];
				G = (unsigned char)buffer[0][j+1];
				B = (unsigned char)buffer[0][j+2];
				*wp2 = (R<<16) | (G<<8) | B;
				wp2++;
			}
		}
	}

	jpeg_finish_decompress(&cinfo);
	jpeg_destroy_decompress(&cinfo);
	fclose(fp);
	return(TRUE);

}

