#ifndef _PIECE_H_
#define _PIECE_H_

#include	"mybit.h"

class PIECE {
public:
	MYBIT	img[8];		//s[Xi0:0x, 1:90x], 2:180x], 3:270x], 4:0̏㉺], 5:1̏㉺], 6:2̏㉺], 7:3̏㉺]j
	RECT	rect;		//ݕ\ʒu
	int		muki;		//0:0x, 1:90x], 2:180x], 3:270x], 4:0̏㉺], 5:1̏㉺], 6:2̏㉺], 7:3̏㉺]
	int		joint;		//WCgԍ
	int		*tonari;	//ׂ̔ԍ̔zi-1̓Xgbp[j
	RECT	org_rect;	//̈ʒu
public:
			PIECE		();
			~PIECE		();
	void	Reset		();
};

class PIECES {
	int		num;				//s[X
	PIECE	piece	[10000];	//s[X
	int		order	[10000];	//\
	MYBIT	*desk;
	MYBIT	*back;
private:
	void	print_table	();
public:
			PIECES		();
			~PIECES		();
	void	Reset		();
	MYBIT*	GetImg		(int no)			{return(&(piece[no].img[ piece[no].muki ]));}
	MYBIT*	GetImgOdr	(int odr)			{return(&(piece[order[odr]].img[ piece[order[odr]].muki ]));}
	MYBIT*	GetImg		(int no, int muki)	{return(&(piece[no].img[ muki ]));}
	RECT	GetRect		(int no)			{return(piece[no].rect);}
	RECT	GetRectOdr	(int odr)			{return(piece[order[odr]].rect);}
	POINT	GetPos		(int no)			{
												POINT	p;
												p.x		= piece[no].rect.left;
												p.y		= piece[no].rect.top;
												return(p);
											}
	POINT	GetPosOdr	(int odr)			{
												POINT	p;
												p.x		= piece[order[odr]].rect.left;
												p.y		= piece[order[odr]].rect.top;
												return(p);
											}
	int		GetOdr		(int odr)			{return(order[odr]);}
	void	SetOdr		(int odr, int no)	{order[odr]=no;}
	void	SetRect		(int no, RECT r)	{piece[no].rect=r;}
	void	SetOrgRect	(int no, RECT r)	{piece[no].org_rect=r;}
	void	SetTonari	(int no, int *t)	{piece[no].tonari=t;}
	void	SetInitV	(int no, int jno, int mk)
											{
												piece[no].joint	= jno;
												piece[no].muki	= mk;
											}
	void	SetNum		(int no)			{num=no;}
	int		GetNum		()					{return(num);}
	int		GetCurNum	();
	int		SelCheck	(POINT mouse);
	int		Select		(int order);								//ordernow肷
	int		Rotate		(int order, POINT mouse, BYTE button);	//ordernow肷
	void	Rotate2		(int no, POINT mouse, BYTE button);
	void	Move		(int dx, int dy);
	void	MMove		(POINT from, POINT to);	//ړ
	BOOL	JointCheck	();						//ŏʃs[XɌqs[XTāA΁AWCg
	void	Separate	(int order);			//s[X؂藣
	POINT	Rotate_XY	(POINT xy, int muki);
	RECT	Rotate_R	(RECT r, int muki);
	RECT	BackClear	(int order);								//ordernow肷
	void	Display		(RECT r1, int from_order, int to_order);	//ordernow肷
	void	Random		(int no,  BOOL kaiten, BOOL hanten, HWND hWnd);
	void	RandomOdr	(int odr, BOOL kaiten, BOOL hanten, HWND hWnd);
	void	Seiretu		(int no);
	void	Save		(char *fname, MYBIT *image, int *num, int *elap);
	int		Load		(char *fname, MYBIT *image, int *num, int *elap);
	int		GetYukouNum	(char *fname, int &cur_num);
	void	GetEndImg	(MYBIT *image, RECT *r);
	void	AddRect		(int dx, int dy, int from, int to);
};

#endif /*_PIECE_H_*/

