#include <windows.h>
#include <stdlib.h>

char		fname[100][MAX_PATH];
int			ext  [100];
int			num;
char		izon[100][100][MAX_PATH];
int			izon_num[100];

void file_list()
{
	WIN32_FIND_DATA	FindFileData;
	HANDLE			handle;
	char			search_fname[MAX_PATH];
	char			path_name   [MAX_PATH];
	int				i;
	char			s_drive     [_MAX_DRIVE];
	char			s_dir       [_MAX_DIR];
	char			s_name      [_MAX_FNAME];
	char			s_ext       [_MAX_EXT];

	lstrcpy(search_fname, "*.*");
	handle = FindFirstFile(search_fname, &FindFileData);
	if (handle==INVALID_HANDLE_VALUE)/*0*/
		return;
	i=0;
	while (FindNextFile(handle, &FindFileData)) {
		lstrcpy(path_name, FindFileData.cFileName);
		_splitpath(path_name, s_drive, s_dir, s_name, s_ext);
		if (lstrcmpi(s_ext, ".cpp")==0) {
			lstrcpy(fname[i], s_name);
			ext[i]	= 1;
			i++;
		}
		else
		if (lstrcmpi(s_ext, ".rc")==0) {
			lstrcpy(fname[i], s_name);
			ext[i]	= 2;
			i++;
		}
		else
		if (lstrcmpi(s_ext, ".h")==0) {
			lstrcpy(fname[i], s_name);
			ext[i]	= 3;
			i++;
		}
	}
	FindClose(handle);
	num		= i;
}

void obj_list(char *obj)
{
	int		i;

	lstrcpy(obj, "object = ");
	for (i=0; i<num; i++) {
		if (ext[i]==1) {//.cpp
			lstrcat(obj, fname[i]);
			lstrcat(obj, ".obj ");
		}
	}
	lstrcat(obj, "\n");
}

BOOL get_str(HANDLE hF, char *str)
{
	char		buf[1000];
	DWORD		dwResult;
	DWORD		i;

	ReadFile(hF, buf, sizeof(buf), &dwResult, NULL);
	if (dwResult==0) {
		str[0]	= '\0';
		return(FALSE);
	}
	for (i=0; i<dwResult; i++) {
		if (buf[i]==0x0a) {
			SetFilePointer(hF, -(int)(dwResult-i-1), NULL, FILE_CURRENT);
			i++;
			break;
		}
	}
	buf[i]	= '\0';
	lstrcpy(str, buf);
	return(TRUE);
}

//.cpp --> [0]="name.obj : name.cpp", [1]="name.h", [2]="name.h"-->izon_num=3
//.rc  --> [0]="name.res : name.rc", [1]="name.h", [2]="name.h"-->izon_num=3
//.h   --> [0]="name.h", [1}="name.h", [2]="name.h", [3]="name.h"-->izon_num=4
void izon_all()
{
	char		name[MAX_PATH];
	char		str [1000];
	char		temp[1000];
	int			i, j, k, l, n;
	DWORD		dwResult;

	for (i=0; i<num; i++) {
		if (ext[i]==1) {//.cpp
			wsprintf(izon[i][0], "%s.obj : %s.cpp", fname[i], fname[i]);
			wsprintf(name, "%s.cpp", fname[i]);
		}
		else if (ext[i]==2) {//.rc
			wsprintf(izon[i][0], "%s.res : %s.rc", fname[i], fname[i]);
			wsprintf(name, "%s.rc", fname[i]);
		}
		else if (ext[i]==3) {//.h
			wsprintf(izon[i][0], "%s.h", fname[i]);
			wsprintf(name, "%s.h", fname[i]);
		}
		n	= 1;
		HANDLE hF = CreateFile(name, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hF != INVALID_HANDLE_VALUE) {
			while (get_str(hF, str)) {
				lstrcpy(temp, str);
				temp[8]	= '\0';
				if (lstrcmp(temp, "#include")==0) {
					izon[i][n][0]	= '\0';
					for (j=9; j<lstrlen(str); j++) {
						if (str[j]=='"') {
							l	= 0;
							for (k=j+1; k<lstrlen(str); k++) {
								if (str[k]=='"')
									break;
								izon[i][n][l++]	= str[k];
							}
							izon[i][n][l]	= '\0';
							break;
						}
					}
					if (lstrlen(izon[i][n])>0)
						n++;
				}
			}
			CloseHandle(hF);
		}
		izon_num[i]		= n;
	}
}

void izon_inc_tenkai()//includeWJ
{
	int		i, j, k, l, m;

	for (i=0; i<num; i++) {
		if (ext[i]==3) {//.h
			for (j=0; j<num; j++) {
				if (j!=i && ext[j]>0) {//ȊO̓WJς݂łȂCN[h
					for (k=1; k<izon_num[j]; k++) {
						if (lstrcmpi(izon[i][0], izon[j][k])==0) {//include
							l	= izon_num[j];
							for (m=1; m<izon_num[i]; m++) {
								lstrcpy(izon[j][l], izon[i][m]);
								l++;
							}
							izon_num[j]		= l;
						}
					}
				}
			}
			ext[i]	= 0;//WJς
		}
	}
}

void izon_inc_del_dup()
{
	int		i, j, k, l, m;

	for (i=0; i<num; i++) {
		if (ext[i]>0) {
			for (j=1; j<izon_num[i]; j++) {
				for (k=j+1; k<izon_num[i]; k++) {
					if (lstrcmpi(izon[i][j], izon[i][k])==0) {//include
						izon[i][k][0]	= '\0';
					}
				}
			}
		}
	}
}

void write_izon(HANDLE write_hF)
{
	DWORD		dwResult;
	char		sp  [2]={0x20, 0x00};
	char		crlf[3]={0x0d, 0x0a, 0x00};
	int			i, j;

	for (i=0; i<num; i++) {
		if (ext[i]>0) {
			for (j=0; j<izon_num[i]; j++) {
				if (lstrlen(izon[i][j])>0) {
					WriteFile(write_hF, izon[i][j], lstrlen(izon[i][j]), &dwResult, NULL);
					WriteFile(write_hF, sp, lstrlen(sp), &dwResult, NULL);
				}
			}
			WriteFile(write_hF, crlf, lstrlen(crlf), &dwResult, NULL);
		}
	}
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPreInst, LPSTR lpszCmdLine, int nCmdShow)
{
	char		buf  [1000];
	DWORD		dwResult;

	file_list();

	DeleteFile("makefile");
	HANDLE write_hF = CreateFile("makefile", GENERIC_WRITE, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

	obj_list(buf);		//.cpp.objXg
	WriteFile(write_hF, buf, lstrlen(buf), &dwResult, NULL);

	HANDLE read_hF  = CreateFile("make_make.ini", GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	ReadFile(read_hF, buf, sizeof(buf), &dwResult, NULL);
	WriteFile(write_hF, buf, dwResult, &dwResult, NULL);
	CloseHandle(read_hF);

	izon_all();			//ˑ֌W𒲂ׂ
	izon_inc_tenkai();	//includeincludeWJ
	izon_inc_del_dup();	//include폜
	
	write_izon(write_hF);

	CloseHandle(write_hF);
	return (0);
}

